var eventLogger = function (d) {
debug('logger= '+d.location);
doc = d;

    this.xml= null;
	if(!mobwars.prefs.getBoolPref("tools.eventlogging.enable")) return;
this.checkNewsFeed();
this.checkAlerts();
    };
	
eventLogger.prototype = {	
checkNewsFeed: function () {
var newsKeywords = ['killed','You won the fight','You lost the fight','added you','awarded','removed','died'];
        var feeds = doc.getElementsByClassName("feedItem");
        for (a = 0; a < feeds.length; a++) {
		news = this.formatEvent(feeds[a]);
            if(!this.dupeCheck(news)) continue;

switch (this.findType(newsKeywords,news)) {
   case '0':
      (mobwars.prefs.getBoolPref("tools.eventlogging.logKills")) ? this.appendToLog(news, "kill") : '';
      break;
   case '1':
      (mobwars.prefs.getBoolPref("tools.eventlogging.logWonfights")) ? this.appendToLog(news, "won") : '';
      break;
   case '2':
      (mobwars.prefs.getBoolPref("tools.eventlogging.logLostfights")) ? this.appendToLog(news, "lost") : '';	
      break;
   case '3':
    (mobwars.prefs.getBoolPref("tools.eventlogging.logHitlistAdds")) ? this.appendToLog(news, "hit") : '';				
      break;
   case '4':
    (mobwars.prefs.getBoolPref("tools.eventlogging.logOtherEvents")) ? this.appendToLog(news, "other") : '';				
      break;
   case '5':
    (mobwars.prefs.getBoolPref("tools.eventlogging.logOtherEvents")) ? this.appendToLog(news, "other") : '';				
      break;	  
   case '6':
    (mobwars.prefs.getBoolPref("tools.eventlogging.logOtherEvents")) ? this.appendToLog(news, "other") : '';				
      break;	  	  
   default:
      break;
}				
        }
},
checkAlerts: function (node) {
var kill=new RegExp("You k[^\.]+");
var alertKeywords = ['successfully','You won the fight','You lost the fight','killed'];
        var alerts = doc.getElementsByClassName("alert");
        for (a = 0; a < alerts.length; a++) {
		news = alerts[a].textContent;

switch (this.findType(alertKeywords,news)) {
   case '0':      
      (mobwars.prefs.getBoolPref("tools.eventlogging.logHitlistAddsOther")) ? this.appendToLog(news, "add") : '';
      break;
   case '1':
      (mobwars.prefs.getBoolPref("tools.eventlogging.logWonfights")) ? this.appendToLog(news, "won") : '';
      break;
   case '2':
      (mobwars.prefs.getBoolPref("tools.eventlogging.logLostfights")) ? this.appendToLog(news, "lost") : '';	
      break;
   case '3':
    (mobwars.prefs.getBoolPref("tools.eventlogging.logKills")) ? this.appendToLog(kill.exec(news), "kill") : '';				
      break;  	  
   default:
      break;
}				
        }	
},
formatEvent: function (node) {
var eventText = node.textContent.replace(/[\d]+[\w\s]+:/gi,'').replace(/\[delete\]/gi,'');
var link = node.getElementsByTagName('a');
for(i=0;i<link.length -1;i++) {
var name = link[i].textContent;
if(/[\d]+/.test(link[i].href)){
var ida = link[i].href.match(/[\d]+/);
eventText = eventText.replace(name,name + ' [' +ida[0]+ '] ');
}
}

return eventText;
},
findType: function (array,str) {
for(var i in array)
    if(str.indexOf(array[i]) != -1) {
	return i;
	}
return -1;
},
    appendToLog: function(msg, type){debug('append');
        this.xml = rw.rFile("eventlog.xml","<announcements><\/announcements>");
        var xmlDoc = this.xml;
        var aNodes = this.evaluateXPath(xmlDoc, "//alert[contains(@id,null)]");
        var newANode = xmlDoc.createElement("alert");
        newANode.setAttribute("id", aNodes.length);
        newANode.setAttribute("type", type);

        var d = new Date();
        var date = d.toLocaleTimeString() + ' ' + d.toLocaleDateString();
        newANode.setAttribute("timestamp", date);
        newANode.textContent = msg;
        var ann = this.evaluateXPath(xmlDoc, "//announcements");
        ann[0].appendChild(newANode);
        // var r = this.evaluateXPath(xmlDoc,"//alert[contains(@id," + aNodes.length + ")]");
        var s = new XMLSerializer();
        var xml = s.serializeToString(xmlDoc);
        rw.wFile('eventlog.xml', xml,"<announcements>\r\n<\/announcements>");
    },
    evaluateXPath: function(aNode, aExpr){
        var xpe = new XPathEvaluator();
        var nsResolver = xpe.createNSResolver(aNode.ownerDocument == null ? aNode.documentElement : aNode.ownerDocument.documentElement);
        var result = xpe.evaluate(aExpr, aNode, nsResolver, 0, null);
        var found = [];
        var res;
        while (res = result.iterateNext()) 
            found.push(res);
        return found;
    },
    transformXML: function(){
        var p = new XSLTProcessor();
        var t = document.implementation.createDocument("", "test", null);
        t.addEventListener("load", onload, false);
        t.load("test-transform.xml");
        function onload(){
            processor.importStylesheet(t);
        }
    },
    dupeCheck: function(msg){
        this.xml = rw.rFile("eventlog.xml","<announcements>\r\n<\/announcements>");
        var xmlDoc = this.xml;
        var aNodes = this.evaluateXPath(xmlDoc, "//alert/text()");
        for (i = 0; i < aNodes.length; i++) {		
            if (aNodes[i].data == msg)
                return false;				
        }
        return true;
    },
};

var logViewer = {
    openLog: function(){
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                   .getService(Components.interfaces.nsIWindowMediator);
logWin = wm.getMostRecentWindow('mt_logwin');
        if (logWin == null || logWin.closed) {
            logWin = window.openDialog("chrome://mobtools/content/eventviewer.xul", "el_window", "chrome,centerscreen,resizable,scrollbars=yes,width=500,height=500");
			logWin.addEventListener("load", function(){
            var t = logWin.document.getElementById("event-tree")
			rw.rFile("eventlog.xml","<announcements><\/announcements>");
			t.datasources = rw.path;
			// t.builder.rebuild();
        }, false);
        }
        else {
            logWin.focus();
        }
    },
    evaluateXPath: function(aNode, aExpr){
        var xpe = new XPathEvaluator();
        var nsResolver = xpe.createNSResolver(aNode.ownerDocument == null ? aNode.documentElement : aNode.ownerDocument.documentElement);
        var result = xpe.evaluate(aExpr, aNode, nsResolver, 0, null);
        var found = [];
        var res;
        while (res = result.iterateNext()) 
            found.push(res);
        return found;
    },	
    clearLog: function(){
	var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService);
	    var r = prompts.confirm(null, "MobTools - Clear Log", "Are you sure you want to clear the event log?");
		if(!r) return;
        this.xml = rw.rFile("eventlog.xml","<announcements>\r\n<\/announcements>");
        var xmlDoc = this.xml;
        var aNodes = this.evaluateXPath(xmlDoc, "//alert[contains(@id,null)]");
        for (var i in aNodes) 
            aNodes[i].parentNode.removeChild(aNodes[i]);
        var s = new XMLSerializer();
        var xml = s.serializeToString(xmlDoc);
        rw.wFile('eventlog.xml', xml,"<announcements>\r\n<\/announcements>");
        // var q = document.getElementById("q1");
        // q.setAttribute("expr", "alert[@type='null']");
        // var t = document.getElementById("event-tree");
        // t.builder.rebuild();
    },	
    filter: function(query){
        var t = document.getElementById("event-tree");
			rw.rFile("eventlog.xml","<announcements><\/announcements>");
			t.datasources = rw.path;
			        t.builder.rebuild();
        var q = document.getElementById("q1");
        q.setAttribute("expr",query );
        var t = document.getElementById("event-tree");
        t.builder.rebuild();
    },
    copy: function(tree,event){
	  var boxobject = tree.treeBoxObject;
	var row = { }, col = { }, child = { };
 boxobject.QueryInterface(Components.interfaces.nsITreeBoxObject);
  boxobject.getCellAt(event.clientX, event.clientY, row, col, child);
  var text = tree.view.getCellText(row.value, col.value);
        var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
        str.data = text;
        var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
        trans.addDataFlavor("text/unicode");
        trans.setTransferData("text/unicode", str, text.length * 2);
        var clipid = Components.interfaces.nsIClipboard;
        var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(clipid);
        clip.setData(trans, null, clipid.kGlobalClipboard);
		
		var alertsService = Components.classes["@mozilla.org/alerts-service;1"]
                              .getService(Components.interfaces.nsIAlertsService);
alertsService.showAlertNotification("chrome://mobtools/skin/images/clipdboard.png", 
                                    'Mobtools', 'The ' + col.value.id + ' "' + text + '" was copied to clipboard', 
                                    false, "", null);
		
        return;
    }
}
