var id = function () {
    };
	
id.prototype = {	
save : function (uid,name) {
// var uid = uid || this.getUID();
// var name = name || this.getName();
// alert(uid);
(typeof uid == 'undefined') ? (uid = this.getUID()) : '';
(typeof name == 'undefined') ? (name = this.getName()) : '';

debug('name = ' + name + '\r\nID = ' + uid);
this.add(name,uid)
},
	  getUID : function() {
      var urx = /[\d]{5,10}/; 
      return gContextMenu.onLink ? urx.exec(gContextMenu.link) : (gContextMenu.isTextSelected ? urx.exec(window.content.getSelection().toString()) : false); 
      },
	  getName : function() {
      return gContextMenu.onLink ? (gContextMenu.link.textContent) : (gContextMenu.isTextSelected ? this.getInputName() : false); 
      },
	  getInputName: function () {
	  var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService);
						var check = {value: false};        
		var input = {value: ""};                 
        var result = prompts.prompt(null, "Mobtools - Save ID", "Enter the username for the saved ID", input,null,check);	
        return (result) ? input.value : '';		
	  },
    add: function(name, id){
        this.xml = rw.rFile("ids.xml","<userlist>\r\n<\/userlist>");
        var xmlDoc = this.xml;
        var aNodes = this.evaluateXPath(xmlDoc, "//user[contains(@id,null)]");
        var newANode = xmlDoc.createElement("user");
        newANode.setAttribute("id", aNodes.length);
        newANode.setAttribute("name", name);
        newANode.setAttribute("uid", id);		
 
        var ann = this.evaluateXPath(xmlDoc, "//userlist");
        ann[0].appendChild(newANode);
        // var r = this.evaluateXPath(xmlDoc,"//alert[contains(@id," + aNodes.length + ")]");
        var s = new XMLSerializer();
        var xml = s.serializeToString(xmlDoc);
        rw.wFile('ids.xml', xml,"<userlist>\r\n<\/userlist>");
    },	  
    evaluateXPath: function(aNode, aExpr){
        var xpe = new XPathEvaluator();
        var nsResolver = xpe.createNSResolver(aNode.ownerDocument == null ? aNode.documentElement : aNode.ownerDocument.documentElement);
        var result = xpe.evaluate(aExpr, aNode, nsResolver, 0, null);
        var found = [];
        var res;
        while (res = result.iterateNext()) 
            found.push(res);
        return found;
    },	  	  
}


var idViewer = {
    openLog: function(){
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                   .getService(Components.interfaces.nsIWindowMediator);
logWin = wm.getMostRecentWindow('mt_idviewer');
        if (logWin == null || logWin.closed) {
            logWin = window.openDialog("chrome://mobtools/content/idviewer.xul", "el_window", "chrome,centerscreen,resizable,scrollbars=yes,width=300,height=500");
			logWin.addEventListener("load", function(){
            var t = logWin.document.getElementById("id-tree")
			rw.rFile("ids.xml","<userlist>\r\n<\/userlist>");
			t.datasources = rw.path;
			// t.builder.rebuild();
        }, false);
        }
        else {
            logWin.focus();
        }
    },
    evaluateXPath: function(aNode, aExpr){
        var xpe = new XPathEvaluator();
        var nsResolver = xpe.createNSResolver(aNode.ownerDocument == null ? aNode.documentElement : aNode.ownerDocument.documentElement);
        var result = xpe.evaluate(aExpr, aNode, nsResolver, 0, null);
        var found = [];
        var res;
        while (res = result.iterateNext()) 
            found.push(res);
        return found;
    },	
    clearLog: function(){
	var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService);
	    var r = prompts.confirm(null, "MobTools - Clear User Log", "Are you sure you want to clear the user log?");
		if(!r) return;
        this.xml = rw.rFile("ids.xml","<userlist>\r\n<\/userlist>");
        var xmlDoc = this.xml;
        var aNodes = this.evaluateXPath(xmlDoc, "//user[contains(@id,null)]");
        for (var i in aNodes) 
            aNodes[i].parentNode.removeChild(aNodes[i]);
        var s = new XMLSerializer();
        var xml = s.serializeToString(xmlDoc);
        rw.wFile('ids.xml', xml,"<userlist>\r\n<\/userlist>");
    },	
    filter: function(query){

        var t = document.getElementById("id-tree");
			rw.rFile("ids.xml","<userlist>\r\n<\/userlist>");
			t.datasources = rw.path;
			        t.builder.rebuild();
        var q = document.getElementById("q1");
        q.setAttribute("expr",query );
        var t = document.getElementById("id-tree");
        t.builder.rebuild();
    },
    copy: function(tree,event){
	if(event.button == 2) return;
	  var boxobject = tree.treeBoxObject;
	var row = { }, col = { }, child = { };
 boxobject.QueryInterface(Components.interfaces.nsITreeBoxObject);
  boxobject.getCellAt(event.clientX, event.clientY, row, col, child);
  var text = tree.view.getCellText(row.value, col.value);
        var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
        str.data = text;
        var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
        trans.addDataFlavor("text/unicode");
        trans.setTransferData("text/unicode", str, text.length * 2);
        var clipid = Components.interfaces.nsIClipboard;
        var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(clipid);
        clip.setData(trans, null, clipid.kGlobalClipboard);
		
		var alertsService = Components.classes["@mozilla.org/alerts-service;1"]
                              .getService(Components.interfaces.nsIAlertsService);
alertsService.showAlertNotification("chrome://mobtools/skin/images/clipdboard.png", 
                                    'Mobtools', 'The ' + col.value.id + ' "' + text + '" was copied to clipboard', 
                                    false, "", null);
		
        return;
    }
}
